package com.mvc.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TIotcardInfoExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public TIotcardInfoExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("ID is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("ID =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("ID <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("ID >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("ID >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("ID <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("ID <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("ID in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("ID not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("ID between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("ID not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andMsisdnIsNull() {
            addCriterion("MSISDN is null");
            return (Criteria) this;
        }

        public Criteria andMsisdnIsNotNull() {
            addCriterion("MSISDN is not null");
            return (Criteria) this;
        }

        public Criteria andMsisdnEqualTo(String value) {
            addCriterion("MSISDN =", value, "msisdn");
            return (Criteria) this;
        }

        public Criteria andMsisdnNotEqualTo(String value) {
            addCriterion("MSISDN <>", value, "msisdn");
            return (Criteria) this;
        }

        public Criteria andMsisdnGreaterThan(String value) {
            addCriterion("MSISDN >", value, "msisdn");
            return (Criteria) this;
        }

        public Criteria andMsisdnGreaterThanOrEqualTo(String value) {
            addCriterion("MSISDN >=", value, "msisdn");
            return (Criteria) this;
        }

        public Criteria andMsisdnLessThan(String value) {
            addCriterion("MSISDN <", value, "msisdn");
            return (Criteria) this;
        }

        public Criteria andMsisdnLessThanOrEqualTo(String value) {
            addCriterion("MSISDN <=", value, "msisdn");
            return (Criteria) this;
        }

        public Criteria andMsisdnLike(String value) {
            addCriterion("MSISDN like", value, "msisdn");
            return (Criteria) this;
        }

        public Criteria andMsisdnNotLike(String value) {
            addCriterion("MSISDN not like", value, "msisdn");
            return (Criteria) this;
        }

        public Criteria andMsisdnIn(List<String> values) {
            addCriterion("MSISDN in", values, "msisdn");
            return (Criteria) this;
        }

        public Criteria andMsisdnNotIn(List<String> values) {
            addCriterion("MSISDN not in", values, "msisdn");
            return (Criteria) this;
        }

        public Criteria andMsisdnBetween(String value1, String value2) {
            addCriterion("MSISDN between", value1, value2, "msisdn");
            return (Criteria) this;
        }

        public Criteria andMsisdnNotBetween(String value1, String value2) {
            addCriterion("MSISDN not between", value1, value2, "msisdn");
            return (Criteria) this;
        }

        public Criteria andIccidIsNull() {
            addCriterion("ICCID is null");
            return (Criteria) this;
        }

        public Criteria andIccidIsNotNull() {
            addCriterion("ICCID is not null");
            return (Criteria) this;
        }

        public Criteria andIccidEqualTo(String value) {
            addCriterion("ICCID =", value, "iccid");
            return (Criteria) this;
        }

        public Criteria andIccidNotEqualTo(String value) {
            addCriterion("ICCID <>", value, "iccid");
            return (Criteria) this;
        }

        public Criteria andIccidGreaterThan(String value) {
            addCriterion("ICCID >", value, "iccid");
            return (Criteria) this;
        }

        public Criteria andIccidGreaterThanOrEqualTo(String value) {
            addCriterion("ICCID >=", value, "iccid");
            return (Criteria) this;
        }

        public Criteria andIccidLessThan(String value) {
            addCriterion("ICCID <", value, "iccid");
            return (Criteria) this;
        }

        public Criteria andIccidLessThanOrEqualTo(String value) {
            addCriterion("ICCID <=", value, "iccid");
            return (Criteria) this;
        }

        public Criteria andIccidLike(String value) {
            addCriterion("ICCID like", value, "iccid");
            return (Criteria) this;
        }

        public Criteria andIccidNotLike(String value) {
            addCriterion("ICCID not like", value, "iccid");
            return (Criteria) this;
        }

        public Criteria andIccidIn(List<String> values) {
            addCriterion("ICCID in", values, "iccid");
            return (Criteria) this;
        }

        public Criteria andIccidNotIn(List<String> values) {
            addCriterion("ICCID not in", values, "iccid");
            return (Criteria) this;
        }

        public Criteria andIccidBetween(String value1, String value2) {
            addCriterion("ICCID between", value1, value2, "iccid");
            return (Criteria) this;
        }

        public Criteria andIccidNotBetween(String value1, String value2) {
            addCriterion("ICCID not between", value1, value2, "iccid");
            return (Criteria) this;
        }

        public Criteria andImsiIsNull() {
            addCriterion("IMSI is null");
            return (Criteria) this;
        }

        public Criteria andImsiIsNotNull() {
            addCriterion("IMSI is not null");
            return (Criteria) this;
        }

        public Criteria andImsiEqualTo(String value) {
            addCriterion("IMSI =", value, "imsi");
            return (Criteria) this;
        }

        public Criteria andImsiNotEqualTo(String value) {
            addCriterion("IMSI <>", value, "imsi");
            return (Criteria) this;
        }

        public Criteria andImsiGreaterThan(String value) {
            addCriterion("IMSI >", value, "imsi");
            return (Criteria) this;
        }

        public Criteria andImsiGreaterThanOrEqualTo(String value) {
            addCriterion("IMSI >=", value, "imsi");
            return (Criteria) this;
        }

        public Criteria andImsiLessThan(String value) {
            addCriterion("IMSI <", value, "imsi");
            return (Criteria) this;
        }

        public Criteria andImsiLessThanOrEqualTo(String value) {
            addCriterion("IMSI <=", value, "imsi");
            return (Criteria) this;
        }

        public Criteria andImsiLike(String value) {
            addCriterion("IMSI like", value, "imsi");
            return (Criteria) this;
        }

        public Criteria andImsiNotLike(String value) {
            addCriterion("IMSI not like", value, "imsi");
            return (Criteria) this;
        }

        public Criteria andImsiIn(List<String> values) {
            addCriterion("IMSI in", values, "imsi");
            return (Criteria) this;
        }

        public Criteria andImsiNotIn(List<String> values) {
            addCriterion("IMSI not in", values, "imsi");
            return (Criteria) this;
        }

        public Criteria andImsiBetween(String value1, String value2) {
            addCriterion("IMSI between", value1, value2, "imsi");
            return (Criteria) this;
        }

        public Criteria andImsiNotBetween(String value1, String value2) {
            addCriterion("IMSI not between", value1, value2, "imsi");
            return (Criteria) this;
        }

        public Criteria andOrgnameIsNull() {
            addCriterion("ORGNAME is null");
            return (Criteria) this;
        }

        public Criteria andOrgnameIsNotNull() {
            addCriterion("ORGNAME is not null");
            return (Criteria) this;
        }

        public Criteria andOrgnameEqualTo(String value) {
            addCriterion("ORGNAME =", value, "orgname");
            return (Criteria) this;
        }

        public Criteria andOrgnameNotEqualTo(String value) {
            addCriterion("ORGNAME <>", value, "orgname");
            return (Criteria) this;
        }

        public Criteria andOrgnameGreaterThan(String value) {
            addCriterion("ORGNAME >", value, "orgname");
            return (Criteria) this;
        }

        public Criteria andOrgnameGreaterThanOrEqualTo(String value) {
            addCriterion("ORGNAME >=", value, "orgname");
            return (Criteria) this;
        }

        public Criteria andOrgnameLessThan(String value) {
            addCriterion("ORGNAME <", value, "orgname");
            return (Criteria) this;
        }

        public Criteria andOrgnameLessThanOrEqualTo(String value) {
            addCriterion("ORGNAME <=", value, "orgname");
            return (Criteria) this;
        }

        public Criteria andOrgnameLike(String value) {
            addCriterion("ORGNAME like", value, "orgname");
            return (Criteria) this;
        }

        public Criteria andOrgnameNotLike(String value) {
            addCriterion("ORGNAME not like", value, "orgname");
            return (Criteria) this;
        }

        public Criteria andOrgnameIn(List<String> values) {
            addCriterion("ORGNAME in", values, "orgname");
            return (Criteria) this;
        }

        public Criteria andOrgnameNotIn(List<String> values) {
            addCriterion("ORGNAME not in", values, "orgname");
            return (Criteria) this;
        }

        public Criteria andOrgnameBetween(String value1, String value2) {
            addCriterion("ORGNAME between", value1, value2, "orgname");
            return (Criteria) this;
        }

        public Criteria andOrgnameNotBetween(String value1, String value2) {
            addCriterion("ORGNAME not between", value1, value2, "orgname");
            return (Criteria) this;
        }

        public Criteria andOperatorIsNull() {
            addCriterion("OPERATOR is null");
            return (Criteria) this;
        }

        public Criteria andOperatorIsNotNull() {
            addCriterion("OPERATOR is not null");
            return (Criteria) this;
        }

        public Criteria andOperatorEqualTo(String value) {
            addCriterion("OPERATOR =", value, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorNotEqualTo(String value) {
            addCriterion("OPERATOR <>", value, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorGreaterThan(String value) {
            addCriterion("OPERATOR >", value, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorGreaterThanOrEqualTo(String value) {
            addCriterion("OPERATOR >=", value, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorLessThan(String value) {
            addCriterion("OPERATOR <", value, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorLessThanOrEqualTo(String value) {
            addCriterion("OPERATOR <=", value, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorLike(String value) {
            addCriterion("OPERATOR like", value, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorNotLike(String value) {
            addCriterion("OPERATOR not like", value, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorIn(List<String> values) {
            addCriterion("OPERATOR in", values, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorNotIn(List<String> values) {
            addCriterion("OPERATOR not in", values, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorBetween(String value1, String value2) {
            addCriterion("OPERATOR between", value1, value2, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorNotBetween(String value1, String value2) {
            addCriterion("OPERATOR not between", value1, value2, "operator");
            return (Criteria) this;
        }

        public Criteria andOwnerplacevalueIsNull() {
            addCriterion("OWNERPLACEVALUE is null");
            return (Criteria) this;
        }

        public Criteria andOwnerplacevalueIsNotNull() {
            addCriterion("OWNERPLACEVALUE is not null");
            return (Criteria) this;
        }

        public Criteria andOwnerplacevalueEqualTo(String value) {
            addCriterion("OWNERPLACEVALUE =", value, "ownerplacevalue");
            return (Criteria) this;
        }

        public Criteria andOwnerplacevalueNotEqualTo(String value) {
            addCriterion("OWNERPLACEVALUE <>", value, "ownerplacevalue");
            return (Criteria) this;
        }

        public Criteria andOwnerplacevalueGreaterThan(String value) {
            addCriterion("OWNERPLACEVALUE >", value, "ownerplacevalue");
            return (Criteria) this;
        }

        public Criteria andOwnerplacevalueGreaterThanOrEqualTo(String value) {
            addCriterion("OWNERPLACEVALUE >=", value, "ownerplacevalue");
            return (Criteria) this;
        }

        public Criteria andOwnerplacevalueLessThan(String value) {
            addCriterion("OWNERPLACEVALUE <", value, "ownerplacevalue");
            return (Criteria) this;
        }

        public Criteria andOwnerplacevalueLessThanOrEqualTo(String value) {
            addCriterion("OWNERPLACEVALUE <=", value, "ownerplacevalue");
            return (Criteria) this;
        }

        public Criteria andOwnerplacevalueLike(String value) {
            addCriterion("OWNERPLACEVALUE like", value, "ownerplacevalue");
            return (Criteria) this;
        }

        public Criteria andOwnerplacevalueNotLike(String value) {
            addCriterion("OWNERPLACEVALUE not like", value, "ownerplacevalue");
            return (Criteria) this;
        }

        public Criteria andOwnerplacevalueIn(List<String> values) {
            addCriterion("OWNERPLACEVALUE in", values, "ownerplacevalue");
            return (Criteria) this;
        }

        public Criteria andOwnerplacevalueNotIn(List<String> values) {
            addCriterion("OWNERPLACEVALUE not in", values, "ownerplacevalue");
            return (Criteria) this;
        }

        public Criteria andOwnerplacevalueBetween(String value1, String value2) {
            addCriterion("OWNERPLACEVALUE between", value1, value2, "ownerplacevalue");
            return (Criteria) this;
        }

        public Criteria andOwnerplacevalueNotBetween(String value1, String value2) {
            addCriterion("OWNERPLACEVALUE not between", value1, value2, "ownerplacevalue");
            return (Criteria) this;
        }

        public Criteria andWorkingconditionIsNull() {
            addCriterion("WORKINGCONDITION is null");
            return (Criteria) this;
        }

        public Criteria andWorkingconditionIsNotNull() {
            addCriterion("WORKINGCONDITION is not null");
            return (Criteria) this;
        }

        public Criteria andWorkingconditionEqualTo(String value) {
            addCriterion("WORKINGCONDITION =", value, "workingcondition");
            return (Criteria) this;
        }

        public Criteria andWorkingconditionNotEqualTo(String value) {
            addCriterion("WORKINGCONDITION <>", value, "workingcondition");
            return (Criteria) this;
        }

        public Criteria andWorkingconditionGreaterThan(String value) {
            addCriterion("WORKINGCONDITION >", value, "workingcondition");
            return (Criteria) this;
        }

        public Criteria andWorkingconditionGreaterThanOrEqualTo(String value) {
            addCriterion("WORKINGCONDITION >=", value, "workingcondition");
            return (Criteria) this;
        }

        public Criteria andWorkingconditionLessThan(String value) {
            addCriterion("WORKINGCONDITION <", value, "workingcondition");
            return (Criteria) this;
        }

        public Criteria andWorkingconditionLessThanOrEqualTo(String value) {
            addCriterion("WORKINGCONDITION <=", value, "workingcondition");
            return (Criteria) this;
        }

        public Criteria andWorkingconditionLike(String value) {
            addCriterion("WORKINGCONDITION like", value, "workingcondition");
            return (Criteria) this;
        }

        public Criteria andWorkingconditionNotLike(String value) {
            addCriterion("WORKINGCONDITION not like", value, "workingcondition");
            return (Criteria) this;
        }

        public Criteria andWorkingconditionIn(List<String> values) {
            addCriterion("WORKINGCONDITION in", values, "workingcondition");
            return (Criteria) this;
        }

        public Criteria andWorkingconditionNotIn(List<String> values) {
            addCriterion("WORKINGCONDITION not in", values, "workingcondition");
            return (Criteria) this;
        }

        public Criteria andWorkingconditionBetween(String value1, String value2) {
            addCriterion("WORKINGCONDITION between", value1, value2, "workingcondition");
            return (Criteria) this;
        }

        public Criteria andWorkingconditionNotBetween(String value1, String value2) {
            addCriterion("WORKINGCONDITION not between", value1, value2, "workingcondition");
            return (Criteria) this;
        }

        public Criteria andOwneridIsNull() {
            addCriterion("OWNERID is null");
            return (Criteria) this;
        }

        public Criteria andOwneridIsNotNull() {
            addCriterion("OWNERID is not null");
            return (Criteria) this;
        }

        public Criteria andOwneridEqualTo(Integer value) {
            addCriterion("OWNERID =", value, "ownerid");
            return (Criteria) this;
        }

        public Criteria andOwneridNotEqualTo(Integer value) {
            addCriterion("OWNERID <>", value, "ownerid");
            return (Criteria) this;
        }

        public Criteria andOwneridGreaterThan(Integer value) {
            addCriterion("OWNERID >", value, "ownerid");
            return (Criteria) this;
        }

        public Criteria andOwneridGreaterThanOrEqualTo(Integer value) {
            addCriterion("OWNERID >=", value, "ownerid");
            return (Criteria) this;
        }

        public Criteria andOwneridLessThan(Integer value) {
            addCriterion("OWNERID <", value, "ownerid");
            return (Criteria) this;
        }

        public Criteria andOwneridLessThanOrEqualTo(Integer value) {
            addCriterion("OWNERID <=", value, "ownerid");
            return (Criteria) this;
        }

        public Criteria andOwneridIn(List<Integer> values) {
            addCriterion("OWNERID in", values, "ownerid");
            return (Criteria) this;
        }

        public Criteria andOwneridNotIn(List<Integer> values) {
            addCriterion("OWNERID not in", values, "ownerid");
            return (Criteria) this;
        }

        public Criteria andOwneridBetween(Integer value1, Integer value2) {
            addCriterion("OWNERID between", value1, value2, "ownerid");
            return (Criteria) this;
        }

        public Criteria andOwneridNotBetween(Integer value1, Integer value2) {
            addCriterion("OWNERID not between", value1, value2, "ownerid");
            return (Criteria) this;
        }

        public Criteria andOwnernameIsNull() {
            addCriterion("OWNERNAME is null");
            return (Criteria) this;
        }

        public Criteria andOwnernameIsNotNull() {
            addCriterion("OWNERNAME is not null");
            return (Criteria) this;
        }

        public Criteria andOwnernameEqualTo(String value) {
            addCriterion("OWNERNAME =", value, "ownername");
            return (Criteria) this;
        }

        public Criteria andOwnernameNotEqualTo(String value) {
            addCriterion("OWNERNAME <>", value, "ownername");
            return (Criteria) this;
        }

        public Criteria andOwnernameGreaterThan(String value) {
            addCriterion("OWNERNAME >", value, "ownername");
            return (Criteria) this;
        }

        public Criteria andOwnernameGreaterThanOrEqualTo(String value) {
            addCriterion("OWNERNAME >=", value, "ownername");
            return (Criteria) this;
        }

        public Criteria andOwnernameLessThan(String value) {
            addCriterion("OWNERNAME <", value, "ownername");
            return (Criteria) this;
        }

        public Criteria andOwnernameLessThanOrEqualTo(String value) {
            addCriterion("OWNERNAME <=", value, "ownername");
            return (Criteria) this;
        }

        public Criteria andOwnernameLike(String value) {
            addCriterion("OWNERNAME like", value, "ownername");
            return (Criteria) this;
        }

        public Criteria andOwnernameNotLike(String value) {
            addCriterion("OWNERNAME not like", value, "ownername");
            return (Criteria) this;
        }

        public Criteria andOwnernameIn(List<String> values) {
            addCriterion("OWNERNAME in", values, "ownername");
            return (Criteria) this;
        }

        public Criteria andOwnernameNotIn(List<String> values) {
            addCriterion("OWNERNAME not in", values, "ownername");
            return (Criteria) this;
        }

        public Criteria andOwnernameBetween(String value1, String value2) {
            addCriterion("OWNERNAME between", value1, value2, "ownername");
            return (Criteria) this;
        }

        public Criteria andOwnernameNotBetween(String value1, String value2) {
            addCriterion("OWNERNAME not between", value1, value2, "ownername");
            return (Criteria) this;
        }

        public Criteria andCombotypeIsNull() {
            addCriterion("COMBOTYPE is null");
            return (Criteria) this;
        }

        public Criteria andCombotypeIsNotNull() {
            addCriterion("COMBOTYPE is not null");
            return (Criteria) this;
        }

        public Criteria andCombotypeEqualTo(String value) {
            addCriterion("COMBOTYPE =", value, "combotype");
            return (Criteria) this;
        }

        public Criteria andCombotypeNotEqualTo(String value) {
            addCriterion("COMBOTYPE <>", value, "combotype");
            return (Criteria) this;
        }

        public Criteria andCombotypeGreaterThan(String value) {
            addCriterion("COMBOTYPE >", value, "combotype");
            return (Criteria) this;
        }

        public Criteria andCombotypeGreaterThanOrEqualTo(String value) {
            addCriterion("COMBOTYPE >=", value, "combotype");
            return (Criteria) this;
        }

        public Criteria andCombotypeLessThan(String value) {
            addCriterion("COMBOTYPE <", value, "combotype");
            return (Criteria) this;
        }

        public Criteria andCombotypeLessThanOrEqualTo(String value) {
            addCriterion("COMBOTYPE <=", value, "combotype");
            return (Criteria) this;
        }

        public Criteria andCombotypeLike(String value) {
            addCriterion("COMBOTYPE like", value, "combotype");
            return (Criteria) this;
        }

        public Criteria andCombotypeNotLike(String value) {
            addCriterion("COMBOTYPE not like", value, "combotype");
            return (Criteria) this;
        }

        public Criteria andCombotypeIn(List<String> values) {
            addCriterion("COMBOTYPE in", values, "combotype");
            return (Criteria) this;
        }

        public Criteria andCombotypeNotIn(List<String> values) {
            addCriterion("COMBOTYPE not in", values, "combotype");
            return (Criteria) this;
        }

        public Criteria andCombotypeBetween(String value1, String value2) {
            addCriterion("COMBOTYPE between", value1, value2, "combotype");
            return (Criteria) this;
        }

        public Criteria andCombotypeNotBetween(String value1, String value2) {
            addCriterion("COMBOTYPE not between", value1, value2, "combotype");
            return (Criteria) this;
        }

        public Criteria andCombonameIsNull() {
            addCriterion("COMBONAME is null");
            return (Criteria) this;
        }

        public Criteria andCombonameIsNotNull() {
            addCriterion("COMBONAME is not null");
            return (Criteria) this;
        }

        public Criteria andCombonameEqualTo(String value) {
            addCriterion("COMBONAME =", value, "comboname");
            return (Criteria) this;
        }

        public Criteria andCombonameNotEqualTo(String value) {
            addCriterion("COMBONAME <>", value, "comboname");
            return (Criteria) this;
        }

        public Criteria andCombonameGreaterThan(String value) {
            addCriterion("COMBONAME >", value, "comboname");
            return (Criteria) this;
        }

        public Criteria andCombonameGreaterThanOrEqualTo(String value) {
            addCriterion("COMBONAME >=", value, "comboname");
            return (Criteria) this;
        }

        public Criteria andCombonameLessThan(String value) {
            addCriterion("COMBONAME <", value, "comboname");
            return (Criteria) this;
        }

        public Criteria andCombonameLessThanOrEqualTo(String value) {
            addCriterion("COMBONAME <=", value, "comboname");
            return (Criteria) this;
        }

        public Criteria andCombonameLike(String value) {
            addCriterion("COMBONAME like", value, "comboname");
            return (Criteria) this;
        }

        public Criteria andCombonameNotLike(String value) {
            addCriterion("COMBONAME not like", value, "comboname");
            return (Criteria) this;
        }

        public Criteria andCombonameIn(List<String> values) {
            addCriterion("COMBONAME in", values, "comboname");
            return (Criteria) this;
        }

        public Criteria andCombonameNotIn(List<String> values) {
            addCriterion("COMBONAME not in", values, "comboname");
            return (Criteria) this;
        }

        public Criteria andCombonameBetween(String value1, String value2) {
            addCriterion("COMBONAME between", value1, value2, "comboname");
            return (Criteria) this;
        }

        public Criteria andCombonameNotBetween(String value1, String value2) {
            addCriterion("COMBONAME not between", value1, value2, "comboname");
            return (Criteria) this;
        }

        public Criteria andCombonamevalueIsNull() {
            addCriterion("COMBONAMEVALUE is null");
            return (Criteria) this;
        }

        public Criteria andCombonamevalueIsNotNull() {
            addCriterion("COMBONAMEVALUE is not null");
            return (Criteria) this;
        }

        public Criteria andCombonamevalueEqualTo(String value) {
            addCriterion("COMBONAMEVALUE =", value, "combonamevalue");
            return (Criteria) this;
        }

        public Criteria andCombonamevalueNotEqualTo(String value) {
            addCriterion("COMBONAMEVALUE <>", value, "combonamevalue");
            return (Criteria) this;
        }

        public Criteria andCombonamevalueGreaterThan(String value) {
            addCriterion("COMBONAMEVALUE >", value, "combonamevalue");
            return (Criteria) this;
        }

        public Criteria andCombonamevalueGreaterThanOrEqualTo(String value) {
            addCriterion("COMBONAMEVALUE >=", value, "combonamevalue");
            return (Criteria) this;
        }

        public Criteria andCombonamevalueLessThan(String value) {
            addCriterion("COMBONAMEVALUE <", value, "combonamevalue");
            return (Criteria) this;
        }

        public Criteria andCombonamevalueLessThanOrEqualTo(String value) {
            addCriterion("COMBONAMEVALUE <=", value, "combonamevalue");
            return (Criteria) this;
        }

        public Criteria andCombonamevalueLike(String value) {
            addCriterion("COMBONAMEVALUE like", value, "combonamevalue");
            return (Criteria) this;
        }

        public Criteria andCombonamevalueNotLike(String value) {
            addCriterion("COMBONAMEVALUE not like", value, "combonamevalue");
            return (Criteria) this;
        }

        public Criteria andCombonamevalueIn(List<String> values) {
            addCriterion("COMBONAMEVALUE in", values, "combonamevalue");
            return (Criteria) this;
        }

        public Criteria andCombonamevalueNotIn(List<String> values) {
            addCriterion("COMBONAMEVALUE not in", values, "combonamevalue");
            return (Criteria) this;
        }

        public Criteria andCombonamevalueBetween(String value1, String value2) {
            addCriterion("COMBONAMEVALUE between", value1, value2, "combonamevalue");
            return (Criteria) this;
        }

        public Criteria andCombonamevalueNotBetween(String value1, String value2) {
            addCriterion("COMBONAMEVALUE not between", value1, value2, "combonamevalue");
            return (Criteria) this;
        }

        public Criteria andTotalgprsIsNull() {
            addCriterion("TOTALGPRS is null");
            return (Criteria) this;
        }

        public Criteria andTotalgprsIsNotNull() {
            addCriterion("TOTALGPRS is not null");
            return (Criteria) this;
        }

        public Criteria andTotalgprsEqualTo(BigDecimal value) {
            addCriterion("TOTALGPRS =", value, "totalgprs");
            return (Criteria) this;
        }

        public Criteria andTotalgprsNotEqualTo(BigDecimal value) {
            addCriterion("TOTALGPRS <>", value, "totalgprs");
            return (Criteria) this;
        }

        public Criteria andTotalgprsGreaterThan(BigDecimal value) {
            addCriterion("TOTALGPRS >", value, "totalgprs");
            return (Criteria) this;
        }

        public Criteria andTotalgprsGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("TOTALGPRS >=", value, "totalgprs");
            return (Criteria) this;
        }

        public Criteria andTotalgprsLessThan(BigDecimal value) {
            addCriterion("TOTALGPRS <", value, "totalgprs");
            return (Criteria) this;
        }

        public Criteria andTotalgprsLessThanOrEqualTo(BigDecimal value) {
            addCriterion("TOTALGPRS <=", value, "totalgprs");
            return (Criteria) this;
        }

        public Criteria andTotalgprsIn(List<BigDecimal> values) {
            addCriterion("TOTALGPRS in", values, "totalgprs");
            return (Criteria) this;
        }

        public Criteria andTotalgprsNotIn(List<BigDecimal> values) {
            addCriterion("TOTALGPRS not in", values, "totalgprs");
            return (Criteria) this;
        }

        public Criteria andTotalgprsBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("TOTALGPRS between", value1, value2, "totalgprs");
            return (Criteria) this;
        }

        public Criteria andTotalgprsNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("TOTALGPRS not between", value1, value2, "totalgprs");
            return (Criteria) this;
        }

        public Criteria andUsegprsIsNull() {
            addCriterion("USEGPRS is null");
            return (Criteria) this;
        }

        public Criteria andUsegprsIsNotNull() {
            addCriterion("USEGPRS is not null");
            return (Criteria) this;
        }

        public Criteria andUsegprsEqualTo(BigDecimal value) {
            addCriterion("USEGPRS =", value, "usegprs");
            return (Criteria) this;
        }

        public Criteria andUsegprsNotEqualTo(BigDecimal value) {
            addCriterion("USEGPRS <>", value, "usegprs");
            return (Criteria) this;
        }

        public Criteria andUsegprsGreaterThan(BigDecimal value) {
            addCriterion("USEGPRS >", value, "usegprs");
            return (Criteria) this;
        }

        public Criteria andUsegprsGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("USEGPRS >=", value, "usegprs");
            return (Criteria) this;
        }

        public Criteria andUsegprsLessThan(BigDecimal value) {
            addCriterion("USEGPRS <", value, "usegprs");
            return (Criteria) this;
        }

        public Criteria andUsegprsLessThanOrEqualTo(BigDecimal value) {
            addCriterion("USEGPRS <=", value, "usegprs");
            return (Criteria) this;
        }

        public Criteria andUsegprsIn(List<BigDecimal> values) {
            addCriterion("USEGPRS in", values, "usegprs");
            return (Criteria) this;
        }

        public Criteria andUsegprsNotIn(List<BigDecimal> values) {
            addCriterion("USEGPRS not in", values, "usegprs");
            return (Criteria) this;
        }

        public Criteria andUsegprsBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("USEGPRS between", value1, value2, "usegprs");
            return (Criteria) this;
        }

        public Criteria andUsegprsNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("USEGPRS not between", value1, value2, "usegprs");
            return (Criteria) this;
        }

        public Criteria andChargegprsIsNull() {
            addCriterion("CHARGEGPRS is null");
            return (Criteria) this;
        }

        public Criteria andChargegprsIsNotNull() {
            addCriterion("CHARGEGPRS is not null");
            return (Criteria) this;
        }

        public Criteria andChargegprsEqualTo(BigDecimal value) {
            addCriterion("CHARGEGPRS =", value, "chargegprs");
            return (Criteria) this;
        }

        public Criteria andChargegprsNotEqualTo(BigDecimal value) {
            addCriterion("CHARGEGPRS <>", value, "chargegprs");
            return (Criteria) this;
        }

        public Criteria andChargegprsGreaterThan(BigDecimal value) {
            addCriterion("CHARGEGPRS >", value, "chargegprs");
            return (Criteria) this;
        }

        public Criteria andChargegprsGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("CHARGEGPRS >=", value, "chargegprs");
            return (Criteria) this;
        }

        public Criteria andChargegprsLessThan(BigDecimal value) {
            addCriterion("CHARGEGPRS <", value, "chargegprs");
            return (Criteria) this;
        }

        public Criteria andChargegprsLessThanOrEqualTo(BigDecimal value) {
            addCriterion("CHARGEGPRS <=", value, "chargegprs");
            return (Criteria) this;
        }

        public Criteria andChargegprsIn(List<BigDecimal> values) {
            addCriterion("CHARGEGPRS in", values, "chargegprs");
            return (Criteria) this;
        }

        public Criteria andChargegprsNotIn(List<BigDecimal> values) {
            addCriterion("CHARGEGPRS not in", values, "chargegprs");
            return (Criteria) this;
        }

        public Criteria andChargegprsBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("CHARGEGPRS between", value1, value2, "chargegprs");
            return (Criteria) this;
        }

        public Criteria andChargegprsNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("CHARGEGPRS not between", value1, value2, "chargegprs");
            return (Criteria) this;
        }

        public Criteria andRemaingprsIsNull() {
            addCriterion("REMAINGPRS is null");
            return (Criteria) this;
        }

        public Criteria andRemaingprsIsNotNull() {
            addCriterion("REMAINGPRS is not null");
            return (Criteria) this;
        }

        public Criteria andRemaingprsEqualTo(BigDecimal value) {
            addCriterion("REMAINGPRS =", value, "remaingprs");
            return (Criteria) this;
        }

        public Criteria andRemaingprsNotEqualTo(BigDecimal value) {
            addCriterion("REMAINGPRS <>", value, "remaingprs");
            return (Criteria) this;
        }

        public Criteria andRemaingprsGreaterThan(BigDecimal value) {
            addCriterion("REMAINGPRS >", value, "remaingprs");
            return (Criteria) this;
        }

        public Criteria andRemaingprsGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("REMAINGPRS >=", value, "remaingprs");
            return (Criteria) this;
        }

        public Criteria andRemaingprsLessThan(BigDecimal value) {
            addCriterion("REMAINGPRS <", value, "remaingprs");
            return (Criteria) this;
        }

        public Criteria andRemaingprsLessThanOrEqualTo(BigDecimal value) {
            addCriterion("REMAINGPRS <=", value, "remaingprs");
            return (Criteria) this;
        }

        public Criteria andRemaingprsIn(List<BigDecimal> values) {
            addCriterion("REMAINGPRS in", values, "remaingprs");
            return (Criteria) this;
        }

        public Criteria andRemaingprsNotIn(List<BigDecimal> values) {
            addCriterion("REMAINGPRS not in", values, "remaingprs");
            return (Criteria) this;
        }

        public Criteria andRemaingprsBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("REMAINGPRS between", value1, value2, "remaingprs");
            return (Criteria) this;
        }

        public Criteria andRemaingprsNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("REMAINGPRS not between", value1, value2, "remaingprs");
            return (Criteria) this;
        }

        public Criteria andOpendateIsNull() {
            addCriterion("OPENDATE is null");
            return (Criteria) this;
        }

        public Criteria andOpendateIsNotNull() {
            addCriterion("OPENDATE is not null");
            return (Criteria) this;
        }

        public Criteria andOpendateEqualTo(String value) {
            addCriterion("OPENDATE =", value, "opendate");
            return (Criteria) this;
        }

        public Criteria andOpendateNotEqualTo(String value) {
            addCriterion("OPENDATE <>", value, "opendate");
            return (Criteria) this;
        }

        public Criteria andOpendateGreaterThan(String value) {
            addCriterion("OPENDATE >", value, "opendate");
            return (Criteria) this;
        }

        public Criteria andOpendateGreaterThanOrEqualTo(String value) {
            addCriterion("OPENDATE >=", value, "opendate");
            return (Criteria) this;
        }

        public Criteria andOpendateLessThan(String value) {
            addCriterion("OPENDATE <", value, "opendate");
            return (Criteria) this;
        }

        public Criteria andOpendateLessThanOrEqualTo(String value) {
            addCriterion("OPENDATE <=", value, "opendate");
            return (Criteria) this;
        }

        public Criteria andOpendateLike(String value) {
            addCriterion("OPENDATE like", value, "opendate");
            return (Criteria) this;
        }

        public Criteria andOpendateNotLike(String value) {
            addCriterion("OPENDATE not like", value, "opendate");
            return (Criteria) this;
        }

        public Criteria andOpendateIn(List<String> values) {
            addCriterion("OPENDATE in", values, "opendate");
            return (Criteria) this;
        }

        public Criteria andOpendateNotIn(List<String> values) {
            addCriterion("OPENDATE not in", values, "opendate");
            return (Criteria) this;
        }

        public Criteria andOpendateBetween(String value1, String value2) {
            addCriterion("OPENDATE between", value1, value2, "opendate");
            return (Criteria) this;
        }

        public Criteria andOpendateNotBetween(String value1, String value2) {
            addCriterion("OPENDATE not between", value1, value2, "opendate");
            return (Criteria) this;
        }

        public Criteria andActivatedateIsNull() {
            addCriterion("ACTIVATEDATE is null");
            return (Criteria) this;
        }

        public Criteria andActivatedateIsNotNull() {
            addCriterion("ACTIVATEDATE is not null");
            return (Criteria) this;
        }

        public Criteria andActivatedateEqualTo(String value) {
            addCriterion("ACTIVATEDATE =", value, "activatedate");
            return (Criteria) this;
        }

        public Criteria andActivatedateNotEqualTo(String value) {
            addCriterion("ACTIVATEDATE <>", value, "activatedate");
            return (Criteria) this;
        }

        public Criteria andActivatedateGreaterThan(String value) {
            addCriterion("ACTIVATEDATE >", value, "activatedate");
            return (Criteria) this;
        }

        public Criteria andActivatedateGreaterThanOrEqualTo(String value) {
            addCriterion("ACTIVATEDATE >=", value, "activatedate");
            return (Criteria) this;
        }

        public Criteria andActivatedateLessThan(String value) {
            addCriterion("ACTIVATEDATE <", value, "activatedate");
            return (Criteria) this;
        }

        public Criteria andActivatedateLessThanOrEqualTo(String value) {
            addCriterion("ACTIVATEDATE <=", value, "activatedate");
            return (Criteria) this;
        }

        public Criteria andActivatedateLike(String value) {
            addCriterion("ACTIVATEDATE like", value, "activatedate");
            return (Criteria) this;
        }

        public Criteria andActivatedateNotLike(String value) {
            addCriterion("ACTIVATEDATE not like", value, "activatedate");
            return (Criteria) this;
        }

        public Criteria andActivatedateIn(List<String> values) {
            addCriterion("ACTIVATEDATE in", values, "activatedate");
            return (Criteria) this;
        }

        public Criteria andActivatedateNotIn(List<String> values) {
            addCriterion("ACTIVATEDATE not in", values, "activatedate");
            return (Criteria) this;
        }

        public Criteria andActivatedateBetween(String value1, String value2) {
            addCriterion("ACTIVATEDATE between", value1, value2, "activatedate");
            return (Criteria) this;
        }

        public Criteria andActivatedateNotBetween(String value1, String value2) {
            addCriterion("ACTIVATEDATE not between", value1, value2, "activatedate");
            return (Criteria) this;
        }

        public Criteria andDuedateIsNull() {
            addCriterion("DUEDATE is null");
            return (Criteria) this;
        }

        public Criteria andDuedateIsNotNull() {
            addCriterion("DUEDATE is not null");
            return (Criteria) this;
        }

        public Criteria andDuedateEqualTo(String value) {
            addCriterion("DUEDATE =", value, "duedate");
            return (Criteria) this;
        }

        public Criteria andDuedateNotEqualTo(String value) {
            addCriterion("DUEDATE <>", value, "duedate");
            return (Criteria) this;
        }

        public Criteria andDuedateGreaterThan(String value) {
            addCriterion("DUEDATE >", value, "duedate");
            return (Criteria) this;
        }

        public Criteria andDuedateGreaterThanOrEqualTo(String value) {
            addCriterion("DUEDATE >=", value, "duedate");
            return (Criteria) this;
        }

        public Criteria andDuedateLessThan(String value) {
            addCriterion("DUEDATE <", value, "duedate");
            return (Criteria) this;
        }

        public Criteria andDuedateLessThanOrEqualTo(String value) {
            addCriterion("DUEDATE <=", value, "duedate");
            return (Criteria) this;
        }

        public Criteria andDuedateLike(String value) {
            addCriterion("DUEDATE like", value, "duedate");
            return (Criteria) this;
        }

        public Criteria andDuedateNotLike(String value) {
            addCriterion("DUEDATE not like", value, "duedate");
            return (Criteria) this;
        }

        public Criteria andDuedateIn(List<String> values) {
            addCriterion("DUEDATE in", values, "duedate");
            return (Criteria) this;
        }

        public Criteria andDuedateNotIn(List<String> values) {
            addCriterion("DUEDATE not in", values, "duedate");
            return (Criteria) this;
        }

        public Criteria andDuedateBetween(String value1, String value2) {
            addCriterion("DUEDATE between", value1, value2, "duedate");
            return (Criteria) this;
        }

        public Criteria andDuedateNotBetween(String value1, String value2) {
            addCriterion("DUEDATE not between", value1, value2, "duedate");
            return (Criteria) this;
        }

        public Criteria andWaittypeIsNull() {
            addCriterion("WAITTYPE is null");
            return (Criteria) this;
        }

        public Criteria andWaittypeIsNotNull() {
            addCriterion("WAITTYPE is not null");
            return (Criteria) this;
        }

        public Criteria andWaittypeEqualTo(String value) {
            addCriterion("WAITTYPE =", value, "waittype");
            return (Criteria) this;
        }

        public Criteria andWaittypeNotEqualTo(String value) {
            addCriterion("WAITTYPE <>", value, "waittype");
            return (Criteria) this;
        }

        public Criteria andWaittypeGreaterThan(String value) {
            addCriterion("WAITTYPE >", value, "waittype");
            return (Criteria) this;
        }

        public Criteria andWaittypeGreaterThanOrEqualTo(String value) {
            addCriterion("WAITTYPE >=", value, "waittype");
            return (Criteria) this;
        }

        public Criteria andWaittypeLessThan(String value) {
            addCriterion("WAITTYPE <", value, "waittype");
            return (Criteria) this;
        }

        public Criteria andWaittypeLessThanOrEqualTo(String value) {
            addCriterion("WAITTYPE <=", value, "waittype");
            return (Criteria) this;
        }

        public Criteria andWaittypeLike(String value) {
            addCriterion("WAITTYPE like", value, "waittype");
            return (Criteria) this;
        }

        public Criteria andWaittypeNotLike(String value) {
            addCriterion("WAITTYPE not like", value, "waittype");
            return (Criteria) this;
        }

        public Criteria andWaittypeIn(List<String> values) {
            addCriterion("WAITTYPE in", values, "waittype");
            return (Criteria) this;
        }

        public Criteria andWaittypeNotIn(List<String> values) {
            addCriterion("WAITTYPE not in", values, "waittype");
            return (Criteria) this;
        }

        public Criteria andWaittypeBetween(String value1, String value2) {
            addCriterion("WAITTYPE between", value1, value2, "waittype");
            return (Criteria) this;
        }

        public Criteria andWaittypeNotBetween(String value1, String value2) {
            addCriterion("WAITTYPE not between", value1, value2, "waittype");
            return (Criteria) this;
        }

        public Criteria andWaitdateIsNull() {
            addCriterion("WAITDATE is null");
            return (Criteria) this;
        }

        public Criteria andWaitdateIsNotNull() {
            addCriterion("WAITDATE is not null");
            return (Criteria) this;
        }

        public Criteria andWaitdateEqualTo(String value) {
            addCriterion("WAITDATE =", value, "waitdate");
            return (Criteria) this;
        }

        public Criteria andWaitdateNotEqualTo(String value) {
            addCriterion("WAITDATE <>", value, "waitdate");
            return (Criteria) this;
        }

        public Criteria andWaitdateGreaterThan(String value) {
            addCriterion("WAITDATE >", value, "waitdate");
            return (Criteria) this;
        }

        public Criteria andWaitdateGreaterThanOrEqualTo(String value) {
            addCriterion("WAITDATE >=", value, "waitdate");
            return (Criteria) this;
        }

        public Criteria andWaitdateLessThan(String value) {
            addCriterion("WAITDATE <", value, "waitdate");
            return (Criteria) this;
        }

        public Criteria andWaitdateLessThanOrEqualTo(String value) {
            addCriterion("WAITDATE <=", value, "waitdate");
            return (Criteria) this;
        }

        public Criteria andWaitdateLike(String value) {
            addCriterion("WAITDATE like", value, "waitdate");
            return (Criteria) this;
        }

        public Criteria andWaitdateNotLike(String value) {
            addCriterion("WAITDATE not like", value, "waitdate");
            return (Criteria) this;
        }

        public Criteria andWaitdateIn(List<String> values) {
            addCriterion("WAITDATE in", values, "waitdate");
            return (Criteria) this;
        }

        public Criteria andWaitdateNotIn(List<String> values) {
            addCriterion("WAITDATE not in", values, "waitdate");
            return (Criteria) this;
        }

        public Criteria andWaitdateBetween(String value1, String value2) {
            addCriterion("WAITDATE between", value1, value2, "waitdate");
            return (Criteria) this;
        }

        public Criteria andWaitdateNotBetween(String value1, String value2) {
            addCriterion("WAITDATE not between", value1, value2, "waitdate");
            return (Criteria) this;
        }

        public Criteria andTesttypeIsNull() {
            addCriterion("TESTTYPE is null");
            return (Criteria) this;
        }

        public Criteria andTesttypeIsNotNull() {
            addCriterion("TESTTYPE is not null");
            return (Criteria) this;
        }

        public Criteria andTesttypeEqualTo(String value) {
            addCriterion("TESTTYPE =", value, "testtype");
            return (Criteria) this;
        }

        public Criteria andTesttypeNotEqualTo(String value) {
            addCriterion("TESTTYPE <>", value, "testtype");
            return (Criteria) this;
        }

        public Criteria andTesttypeGreaterThan(String value) {
            addCriterion("TESTTYPE >", value, "testtype");
            return (Criteria) this;
        }

        public Criteria andTesttypeGreaterThanOrEqualTo(String value) {
            addCriterion("TESTTYPE >=", value, "testtype");
            return (Criteria) this;
        }

        public Criteria andTesttypeLessThan(String value) {
            addCriterion("TESTTYPE <", value, "testtype");
            return (Criteria) this;
        }

        public Criteria andTesttypeLessThanOrEqualTo(String value) {
            addCriterion("TESTTYPE <=", value, "testtype");
            return (Criteria) this;
        }

        public Criteria andTesttypeLike(String value) {
            addCriterion("TESTTYPE like", value, "testtype");
            return (Criteria) this;
        }

        public Criteria andTesttypeNotLike(String value) {
            addCriterion("TESTTYPE not like", value, "testtype");
            return (Criteria) this;
        }

        public Criteria andTesttypeIn(List<String> values) {
            addCriterion("TESTTYPE in", values, "testtype");
            return (Criteria) this;
        }

        public Criteria andTesttypeNotIn(List<String> values) {
            addCriterion("TESTTYPE not in", values, "testtype");
            return (Criteria) this;
        }

        public Criteria andTesttypeBetween(String value1, String value2) {
            addCriterion("TESTTYPE between", value1, value2, "testtype");
            return (Criteria) this;
        }

        public Criteria andTesttypeNotBetween(String value1, String value2) {
            addCriterion("TESTTYPE not between", value1, value2, "testtype");
            return (Criteria) this;
        }

        public Criteria andTestdateIsNull() {
            addCriterion("TESTDATE is null");
            return (Criteria) this;
        }

        public Criteria andTestdateIsNotNull() {
            addCriterion("TESTDATE is not null");
            return (Criteria) this;
        }

        public Criteria andTestdateEqualTo(String value) {
            addCriterion("TESTDATE =", value, "testdate");
            return (Criteria) this;
        }

        public Criteria andTestdateNotEqualTo(String value) {
            addCriterion("TESTDATE <>", value, "testdate");
            return (Criteria) this;
        }

        public Criteria andTestdateGreaterThan(String value) {
            addCriterion("TESTDATE >", value, "testdate");
            return (Criteria) this;
        }

        public Criteria andTestdateGreaterThanOrEqualTo(String value) {
            addCriterion("TESTDATE >=", value, "testdate");
            return (Criteria) this;
        }

        public Criteria andTestdateLessThan(String value) {
            addCriterion("TESTDATE <", value, "testdate");
            return (Criteria) this;
        }

        public Criteria andTestdateLessThanOrEqualTo(String value) {
            addCriterion("TESTDATE <=", value, "testdate");
            return (Criteria) this;
        }

        public Criteria andTestdateLike(String value) {
            addCriterion("TESTDATE like", value, "testdate");
            return (Criteria) this;
        }

        public Criteria andTestdateNotLike(String value) {
            addCriterion("TESTDATE not like", value, "testdate");
            return (Criteria) this;
        }

        public Criteria andTestdateIn(List<String> values) {
            addCriterion("TESTDATE in", values, "testdate");
            return (Criteria) this;
        }

        public Criteria andTestdateNotIn(List<String> values) {
            addCriterion("TESTDATE not in", values, "testdate");
            return (Criteria) this;
        }

        public Criteria andTestdateBetween(String value1, String value2) {
            addCriterion("TESTDATE between", value1, value2, "testdate");
            return (Criteria) this;
        }

        public Criteria andTestdateNotBetween(String value1, String value2) {
            addCriterion("TESTDATE not between", value1, value2, "testdate");
            return (Criteria) this;
        }

        public Criteria andIsorienteerIsNull() {
            addCriterion("ISORIENTEER is null");
            return (Criteria) this;
        }

        public Criteria andIsorienteerIsNotNull() {
            addCriterion("ISORIENTEER is not null");
            return (Criteria) this;
        }

        public Criteria andIsorienteerEqualTo(String value) {
            addCriterion("ISORIENTEER =", value, "isorienteer");
            return (Criteria) this;
        }

        public Criteria andIsorienteerNotEqualTo(String value) {
            addCriterion("ISORIENTEER <>", value, "isorienteer");
            return (Criteria) this;
        }

        public Criteria andIsorienteerGreaterThan(String value) {
            addCriterion("ISORIENTEER >", value, "isorienteer");
            return (Criteria) this;
        }

        public Criteria andIsorienteerGreaterThanOrEqualTo(String value) {
            addCriterion("ISORIENTEER >=", value, "isorienteer");
            return (Criteria) this;
        }

        public Criteria andIsorienteerLessThan(String value) {
            addCriterion("ISORIENTEER <", value, "isorienteer");
            return (Criteria) this;
        }

        public Criteria andIsorienteerLessThanOrEqualTo(String value) {
            addCriterion("ISORIENTEER <=", value, "isorienteer");
            return (Criteria) this;
        }

        public Criteria andIsorienteerLike(String value) {
            addCriterion("ISORIENTEER like", value, "isorienteer");
            return (Criteria) this;
        }

        public Criteria andIsorienteerNotLike(String value) {
            addCriterion("ISORIENTEER not like", value, "isorienteer");
            return (Criteria) this;
        }

        public Criteria andIsorienteerIn(List<String> values) {
            addCriterion("ISORIENTEER in", values, "isorienteer");
            return (Criteria) this;
        }

        public Criteria andIsorienteerNotIn(List<String> values) {
            addCriterion("ISORIENTEER not in", values, "isorienteer");
            return (Criteria) this;
        }

        public Criteria andIsorienteerBetween(String value1, String value2) {
            addCriterion("ISORIENTEER between", value1, value2, "isorienteer");
            return (Criteria) this;
        }

        public Criteria andIsorienteerNotBetween(String value1, String value2) {
            addCriterion("ISORIENTEER not between", value1, value2, "isorienteer");
            return (Criteria) this;
        }

        public Criteria andLifecycleIsNull() {
            addCriterion("LIFECYCLE is null");
            return (Criteria) this;
        }

        public Criteria andLifecycleIsNotNull() {
            addCriterion("LIFECYCLE is not null");
            return (Criteria) this;
        }

        public Criteria andLifecycleEqualTo(String value) {
            addCriterion("LIFECYCLE =", value, "lifecycle");
            return (Criteria) this;
        }

        public Criteria andLifecycleNotEqualTo(String value) {
            addCriterion("LIFECYCLE <>", value, "lifecycle");
            return (Criteria) this;
        }

        public Criteria andLifecycleGreaterThan(String value) {
            addCriterion("LIFECYCLE >", value, "lifecycle");
            return (Criteria) this;
        }

        public Criteria andLifecycleGreaterThanOrEqualTo(String value) {
            addCriterion("LIFECYCLE >=", value, "lifecycle");
            return (Criteria) this;
        }

        public Criteria andLifecycleLessThan(String value) {
            addCriterion("LIFECYCLE <", value, "lifecycle");
            return (Criteria) this;
        }

        public Criteria andLifecycleLessThanOrEqualTo(String value) {
            addCriterion("LIFECYCLE <=", value, "lifecycle");
            return (Criteria) this;
        }

        public Criteria andLifecycleLike(String value) {
            addCriterion("LIFECYCLE like", value, "lifecycle");
            return (Criteria) this;
        }

        public Criteria andLifecycleNotLike(String value) {
            addCriterion("LIFECYCLE not like", value, "lifecycle");
            return (Criteria) this;
        }

        public Criteria andLifecycleIn(List<String> values) {
            addCriterion("LIFECYCLE in", values, "lifecycle");
            return (Criteria) this;
        }

        public Criteria andLifecycleNotIn(List<String> values) {
            addCriterion("LIFECYCLE not in", values, "lifecycle");
            return (Criteria) this;
        }

        public Criteria andLifecycleBetween(String value1, String value2) {
            addCriterion("LIFECYCLE between", value1, value2, "lifecycle");
            return (Criteria) this;
        }

        public Criteria andLifecycleNotBetween(String value1, String value2) {
            addCriterion("LIFECYCLE not between", value1, value2, "lifecycle");
            return (Criteria) this;
        }

        public Criteria andVoicecombotypeIsNull() {
            addCriterion("VOICECOMBOTYPE is null");
            return (Criteria) this;
        }

        public Criteria andVoicecombotypeIsNotNull() {
            addCriterion("VOICECOMBOTYPE is not null");
            return (Criteria) this;
        }

        public Criteria andVoicecombotypeEqualTo(String value) {
            addCriterion("VOICECOMBOTYPE =", value, "voicecombotype");
            return (Criteria) this;
        }

        public Criteria andVoicecombotypeNotEqualTo(String value) {
            addCriterion("VOICECOMBOTYPE <>", value, "voicecombotype");
            return (Criteria) this;
        }

        public Criteria andVoicecombotypeGreaterThan(String value) {
            addCriterion("VOICECOMBOTYPE >", value, "voicecombotype");
            return (Criteria) this;
        }

        public Criteria andVoicecombotypeGreaterThanOrEqualTo(String value) {
            addCriterion("VOICECOMBOTYPE >=", value, "voicecombotype");
            return (Criteria) this;
        }

        public Criteria andVoicecombotypeLessThan(String value) {
            addCriterion("VOICECOMBOTYPE <", value, "voicecombotype");
            return (Criteria) this;
        }

        public Criteria andVoicecombotypeLessThanOrEqualTo(String value) {
            addCriterion("VOICECOMBOTYPE <=", value, "voicecombotype");
            return (Criteria) this;
        }

        public Criteria andVoicecombotypeLike(String value) {
            addCriterion("VOICECOMBOTYPE like", value, "voicecombotype");
            return (Criteria) this;
        }

        public Criteria andVoicecombotypeNotLike(String value) {
            addCriterion("VOICECOMBOTYPE not like", value, "voicecombotype");
            return (Criteria) this;
        }

        public Criteria andVoicecombotypeIn(List<String> values) {
            addCriterion("VOICECOMBOTYPE in", values, "voicecombotype");
            return (Criteria) this;
        }

        public Criteria andVoicecombotypeNotIn(List<String> values) {
            addCriterion("VOICECOMBOTYPE not in", values, "voicecombotype");
            return (Criteria) this;
        }

        public Criteria andVoicecombotypeBetween(String value1, String value2) {
            addCriterion("VOICECOMBOTYPE between", value1, value2, "voicecombotype");
            return (Criteria) this;
        }

        public Criteria andVoicecombotypeNotBetween(String value1, String value2) {
            addCriterion("VOICECOMBOTYPE not between", value1, value2, "voicecombotype");
            return (Criteria) this;
        }

        public Criteria andVoicecombonameIsNull() {
            addCriterion("VOICECOMBONAME is null");
            return (Criteria) this;
        }

        public Criteria andVoicecombonameIsNotNull() {
            addCriterion("VOICECOMBONAME is not null");
            return (Criteria) this;
        }

        public Criteria andVoicecombonameEqualTo(String value) {
            addCriterion("VOICECOMBONAME =", value, "voicecomboname");
            return (Criteria) this;
        }

        public Criteria andVoicecombonameNotEqualTo(String value) {
            addCriterion("VOICECOMBONAME <>", value, "voicecomboname");
            return (Criteria) this;
        }

        public Criteria andVoicecombonameGreaterThan(String value) {
            addCriterion("VOICECOMBONAME >", value, "voicecomboname");
            return (Criteria) this;
        }

        public Criteria andVoicecombonameGreaterThanOrEqualTo(String value) {
            addCriterion("VOICECOMBONAME >=", value, "voicecomboname");
            return (Criteria) this;
        }

        public Criteria andVoicecombonameLessThan(String value) {
            addCriterion("VOICECOMBONAME <", value, "voicecomboname");
            return (Criteria) this;
        }

        public Criteria andVoicecombonameLessThanOrEqualTo(String value) {
            addCriterion("VOICECOMBONAME <=", value, "voicecomboname");
            return (Criteria) this;
        }

        public Criteria andVoicecombonameLike(String value) {
            addCriterion("VOICECOMBONAME like", value, "voicecomboname");
            return (Criteria) this;
        }

        public Criteria andVoicecombonameNotLike(String value) {
            addCriterion("VOICECOMBONAME not like", value, "voicecomboname");
            return (Criteria) this;
        }

        public Criteria andVoicecombonameIn(List<String> values) {
            addCriterion("VOICECOMBONAME in", values, "voicecomboname");
            return (Criteria) this;
        }

        public Criteria andVoicecombonameNotIn(List<String> values) {
            addCriterion("VOICECOMBONAME not in", values, "voicecomboname");
            return (Criteria) this;
        }

        public Criteria andVoicecombonameBetween(String value1, String value2) {
            addCriterion("VOICECOMBONAME between", value1, value2, "voicecomboname");
            return (Criteria) this;
        }

        public Criteria andVoicecombonameNotBetween(String value1, String value2) {
            addCriterion("VOICECOMBONAME not between", value1, value2, "voicecomboname");
            return (Criteria) this;
        }

        public Criteria andTotalvoiceIsNull() {
            addCriterion("TOTALVOICE is null");
            return (Criteria) this;
        }

        public Criteria andTotalvoiceIsNotNull() {
            addCriterion("TOTALVOICE is not null");
            return (Criteria) this;
        }

        public Criteria andTotalvoiceEqualTo(Long value) {
            addCriterion("TOTALVOICE =", value, "totalvoice");
            return (Criteria) this;
        }

        public Criteria andTotalvoiceNotEqualTo(Long value) {
            addCriterion("TOTALVOICE <>", value, "totalvoice");
            return (Criteria) this;
        }

        public Criteria andTotalvoiceGreaterThan(Long value) {
            addCriterion("TOTALVOICE >", value, "totalvoice");
            return (Criteria) this;
        }

        public Criteria andTotalvoiceGreaterThanOrEqualTo(Long value) {
            addCriterion("TOTALVOICE >=", value, "totalvoice");
            return (Criteria) this;
        }

        public Criteria andTotalvoiceLessThan(Long value) {
            addCriterion("TOTALVOICE <", value, "totalvoice");
            return (Criteria) this;
        }

        public Criteria andTotalvoiceLessThanOrEqualTo(Long value) {
            addCriterion("TOTALVOICE <=", value, "totalvoice");
            return (Criteria) this;
        }

        public Criteria andTotalvoiceIn(List<Long> values) {
            addCriterion("TOTALVOICE in", values, "totalvoice");
            return (Criteria) this;
        }

        public Criteria andTotalvoiceNotIn(List<Long> values) {
            addCriterion("TOTALVOICE not in", values, "totalvoice");
            return (Criteria) this;
        }

        public Criteria andTotalvoiceBetween(Long value1, Long value2) {
            addCriterion("TOTALVOICE between", value1, value2, "totalvoice");
            return (Criteria) this;
        }

        public Criteria andTotalvoiceNotBetween(Long value1, Long value2) {
            addCriterion("TOTALVOICE not between", value1, value2, "totalvoice");
            return (Criteria) this;
        }

        public Criteria andUsevoiceIsNull() {
            addCriterion("USEVOICE is null");
            return (Criteria) this;
        }

        public Criteria andUsevoiceIsNotNull() {
            addCriterion("USEVOICE is not null");
            return (Criteria) this;
        }

        public Criteria andUsevoiceEqualTo(Long value) {
            addCriterion("USEVOICE =", value, "usevoice");
            return (Criteria) this;
        }

        public Criteria andUsevoiceNotEqualTo(Long value) {
            addCriterion("USEVOICE <>", value, "usevoice");
            return (Criteria) this;
        }

        public Criteria andUsevoiceGreaterThan(Long value) {
            addCriterion("USEVOICE >", value, "usevoice");
            return (Criteria) this;
        }

        public Criteria andUsevoiceGreaterThanOrEqualTo(Long value) {
            addCriterion("USEVOICE >=", value, "usevoice");
            return (Criteria) this;
        }

        public Criteria andUsevoiceLessThan(Long value) {
            addCriterion("USEVOICE <", value, "usevoice");
            return (Criteria) this;
        }

        public Criteria andUsevoiceLessThanOrEqualTo(Long value) {
            addCriterion("USEVOICE <=", value, "usevoice");
            return (Criteria) this;
        }

        public Criteria andUsevoiceIn(List<Long> values) {
            addCriterion("USEVOICE in", values, "usevoice");
            return (Criteria) this;
        }

        public Criteria andUsevoiceNotIn(List<Long> values) {
            addCriterion("USEVOICE not in", values, "usevoice");
            return (Criteria) this;
        }

        public Criteria andUsevoiceBetween(Long value1, Long value2) {
            addCriterion("USEVOICE between", value1, value2, "usevoice");
            return (Criteria) this;
        }

        public Criteria andUsevoiceNotBetween(Long value1, Long value2) {
            addCriterion("USEVOICE not between", value1, value2, "usevoice");
            return (Criteria) this;
        }

        public Criteria andRemainvoiceIsNull() {
            addCriterion("REMAINVOICE is null");
            return (Criteria) this;
        }

        public Criteria andRemainvoiceIsNotNull() {
            addCriterion("REMAINVOICE is not null");
            return (Criteria) this;
        }

        public Criteria andRemainvoiceEqualTo(Long value) {
            addCriterion("REMAINVOICE =", value, "remainvoice");
            return (Criteria) this;
        }

        public Criteria andRemainvoiceNotEqualTo(Long value) {
            addCriterion("REMAINVOICE <>", value, "remainvoice");
            return (Criteria) this;
        }

        public Criteria andRemainvoiceGreaterThan(Long value) {
            addCriterion("REMAINVOICE >", value, "remainvoice");
            return (Criteria) this;
        }

        public Criteria andRemainvoiceGreaterThanOrEqualTo(Long value) {
            addCriterion("REMAINVOICE >=", value, "remainvoice");
            return (Criteria) this;
        }

        public Criteria andRemainvoiceLessThan(Long value) {
            addCriterion("REMAINVOICE <", value, "remainvoice");
            return (Criteria) this;
        }

        public Criteria andRemainvoiceLessThanOrEqualTo(Long value) {
            addCriterion("REMAINVOICE <=", value, "remainvoice");
            return (Criteria) this;
        }

        public Criteria andRemainvoiceIn(List<Long> values) {
            addCriterion("REMAINVOICE in", values, "remainvoice");
            return (Criteria) this;
        }

        public Criteria andRemainvoiceNotIn(List<Long> values) {
            addCriterion("REMAINVOICE not in", values, "remainvoice");
            return (Criteria) this;
        }

        public Criteria andRemainvoiceBetween(Long value1, Long value2) {
            addCriterion("REMAINVOICE between", value1, value2, "remainvoice");
            return (Criteria) this;
        }

        public Criteria andRemainvoiceNotBetween(Long value1, Long value2) {
            addCriterion("REMAINVOICE not between", value1, value2, "remainvoice");
            return (Criteria) this;
        }

        public Criteria andArrearageIsNull() {
            addCriterion("ARREARAGE is null");
            return (Criteria) this;
        }

        public Criteria andArrearageIsNotNull() {
            addCriterion("ARREARAGE is not null");
            return (Criteria) this;
        }

        public Criteria andArrearageEqualTo(Integer value) {
            addCriterion("ARREARAGE =", value, "arrearage");
            return (Criteria) this;
        }

        public Criteria andArrearageNotEqualTo(Integer value) {
            addCriterion("ARREARAGE <>", value, "arrearage");
            return (Criteria) this;
        }

        public Criteria andArrearageGreaterThan(Integer value) {
            addCriterion("ARREARAGE >", value, "arrearage");
            return (Criteria) this;
        }

        public Criteria andArrearageGreaterThanOrEqualTo(Integer value) {
            addCriterion("ARREARAGE >=", value, "arrearage");
            return (Criteria) this;
        }

        public Criteria andArrearageLessThan(Integer value) {
            addCriterion("ARREARAGE <", value, "arrearage");
            return (Criteria) this;
        }

        public Criteria andArrearageLessThanOrEqualTo(Integer value) {
            addCriterion("ARREARAGE <=", value, "arrearage");
            return (Criteria) this;
        }

        public Criteria andArrearageIn(List<Integer> values) {
            addCriterion("ARREARAGE in", values, "arrearage");
            return (Criteria) this;
        }

        public Criteria andArrearageNotIn(List<Integer> values) {
            addCriterion("ARREARAGE not in", values, "arrearage");
            return (Criteria) this;
        }

        public Criteria andArrearageBetween(Integer value1, Integer value2) {
            addCriterion("ARREARAGE between", value1, value2, "arrearage");
            return (Criteria) this;
        }

        public Criteria andArrearageNotBetween(Integer value1, Integer value2) {
            addCriterion("ARREARAGE not between", value1, value2, "arrearage");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNull() {
            addCriterion("DEVICE_SN is null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNotNull() {
            addCriterion("DEVICE_SN is not null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnEqualTo(String value) {
            addCriterion("DEVICE_SN =", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotEqualTo(String value) {
            addCriterion("DEVICE_SN <>", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThan(String value) {
            addCriterion("DEVICE_SN >", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThanOrEqualTo(String value) {
            addCriterion("DEVICE_SN >=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThan(String value) {
            addCriterion("DEVICE_SN <", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThanOrEqualTo(String value) {
            addCriterion("DEVICE_SN <=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLike(String value) {
            addCriterion("DEVICE_SN like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotLike(String value) {
            addCriterion("DEVICE_SN not like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIn(List<String> values) {
            addCriterion("DEVICE_SN in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotIn(List<String> values) {
            addCriterion("DEVICE_SN not in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnBetween(String value1, String value2) {
            addCriterion("DEVICE_SN between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotBetween(String value1, String value2) {
            addCriterion("DEVICE_SN not between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andAireadIdIsNull() {
            addCriterion("AIREAD_ID is null");
            return (Criteria) this;
        }

        public Criteria andAireadIdIsNotNull() {
            addCriterion("AIREAD_ID is not null");
            return (Criteria) this;
        }

        public Criteria andAireadIdEqualTo(Integer value) {
            addCriterion("AIREAD_ID =", value, "aireadId");
            return (Criteria) this;
        }

        public Criteria andAireadIdNotEqualTo(Integer value) {
            addCriterion("AIREAD_ID <>", value, "aireadId");
            return (Criteria) this;
        }

        public Criteria andAireadIdGreaterThan(Integer value) {
            addCriterion("AIREAD_ID >", value, "aireadId");
            return (Criteria) this;
        }

        public Criteria andAireadIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("AIREAD_ID >=", value, "aireadId");
            return (Criteria) this;
        }

        public Criteria andAireadIdLessThan(Integer value) {
            addCriterion("AIREAD_ID <", value, "aireadId");
            return (Criteria) this;
        }

        public Criteria andAireadIdLessThanOrEqualTo(Integer value) {
            addCriterion("AIREAD_ID <=", value, "aireadId");
            return (Criteria) this;
        }

        public Criteria andAireadIdIn(List<Integer> values) {
            addCriterion("AIREAD_ID in", values, "aireadId");
            return (Criteria) this;
        }

        public Criteria andAireadIdNotIn(List<Integer> values) {
            addCriterion("AIREAD_ID not in", values, "aireadId");
            return (Criteria) this;
        }

        public Criteria andAireadIdBetween(Integer value1, Integer value2) {
            addCriterion("AIREAD_ID between", value1, value2, "aireadId");
            return (Criteria) this;
        }

        public Criteria andAireadIdNotBetween(Integer value1, Integer value2) {
            addCriterion("AIREAD_ID not between", value1, value2, "aireadId");
            return (Criteria) this;
        }

        public Criteria andSampleTimeIsNull() {
            addCriterion("SAMPLE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andSampleTimeIsNotNull() {
            addCriterion("SAMPLE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andSampleTimeEqualTo(Date value) {
            addCriterion("SAMPLE_TIME =", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeNotEqualTo(Date value) {
            addCriterion("SAMPLE_TIME <>", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeGreaterThan(Date value) {
            addCriterion("SAMPLE_TIME >", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("SAMPLE_TIME >=", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeLessThan(Date value) {
            addCriterion("SAMPLE_TIME <", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeLessThanOrEqualTo(Date value) {
            addCriterion("SAMPLE_TIME <=", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeIn(List<Date> values) {
            addCriterion("SAMPLE_TIME in", values, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeNotIn(List<Date> values) {
            addCriterion("SAMPLE_TIME not in", values, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeBetween(Date value1, Date value2) {
            addCriterion("SAMPLE_TIME between", value1, value2, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeNotBetween(Date value1, Date value2) {
            addCriterion("SAMPLE_TIME not between", value1, value2, "sampleTime");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}